﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ff14bot;
using ff14bot.Managers;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using System.Windows.Media;
using Buddy.Coroutines;
using System.Threading.Tasks;
using ff14bot.AClasses;
using ff14bot.RemoteWindows;
using System.Diagnostics;

namespace ChocoboPlugin
{
    public class ChocoboPlugin : IBotPlugin
    {
        public string Author { get { return "akderebur"; } }
        public string Description { get { return "Chocobo race spammer"; } }
        public Version Version { get { return new Version(1, 0, 0); } }
        public string Name { get { return "ChocoboRacer"; } }
        public string ButtonText { get { return "No Settings"; } }
        public bool WantButton { get { return true; } }
        public bool Equals(IBotPlugin other) { throw new NotImplementedException(); }

        ImageUtils imgUtils = new ImageUtils();
        public static IntPtr gameHandle = IntPtr.Zero;
        private ff14bot.Objects.GameObject chocoNpc = null;

        public void OnInitialize()
        {
        }

        public void OnEnabled()
        {
            //Need game handle to force the game window to be in front of everything else
            Process[] tempProcesses = Process.GetProcessesByName("ffxiv");
            if (tempProcesses.Length == 0)
                Log.Write("FFXIV is not running.");
            else
                gameHandle = tempProcesses[0].MainWindowHandle;

            TreeRoot.OnStop += TreeRootOnOnStop;
        }

        private Coroutine _coroutine;

        public void OnPulse()
        {
            if (_coroutine == null || _coroutine.IsFinished)
            {
                _coroutine = new Coroutine(() => MainLoop());
            }

            _coroutine.Resume();
        }


        internal async Task MainLoop()
        {
            chocoNpc = GameObjectManager.GetObjectByNPCId(1010464);

            while (true)
            {
                //Start talk with Chocobo Registrar
                chocoNpc.Interact();

                //Wait for dialog to open
                while (!ff14bot.RemoteWindows.Talk.DialogOpen)
                    await Coroutine.Sleep(1000);

                //Skip dialog
                ff14bot.RemoteWindows.Talk.Next();

                await Coroutine.Sleep(1000);

                //Select "Enter a race" button
                while (ff14bot.RemoteWindows.SelectString.ClickLineContains("Enter a race"))
                    await Coroutine.Sleep(1000);

                //Select Open as class
                while (ff14bot.RemoteWindows.SelectString.ClickLineContains("Open"))
                    await Coroutine.Sleep(1000);

                //Select random field
                while (ff14bot.RemoteWindows.SelectString.ClickLineContains("Random"))
                    await Coroutine.Sleep(1000);

                //Wait for confirmation window
                while (!ff14bot.RemoteWindows.SelectYesno.IsOpen)
                    await Coroutine.Sleep(1000);

                //Click yes when asked to spend MGP
                ff14bot.RemoteWindows.SelectYesno.ClickYes();

                //Waşt for dialog
                while (!ff14bot.RemoteWindows.Talk.DialogOpen)
                    await Coroutine.Sleep(1000);

                //Skip dialog
                ff14bot.RemoteWindows.Talk.Next();

                //Wait for race button to appear and click it. If Chocobo Registrar is not visible, then we are in race
                while (chocoNpcVis())
                {
                    imgUtils.checkButton(imgUtils.raceButton);
                    await Coroutine.Sleep(3000);
                }

                //Do this routine 15 times before searching for the leave button (Roughly a normal race time)
                //Checking leave button from start is unnecessary and impacts performance
                int loopTime = 0;
                while (loopTime < 17)
                {
                    InputManager.KeyDown();
                    await Coroutine.Sleep(8000);
                    InputManager.KeyUp();
                    await Coroutine.Sleep(3000);

                    loopTime++;
                }
                //Wait for the leave button to become available and click it
                while (!imgUtils.checkButton(imgUtils.leaveButton))
                    await Coroutine.Sleep(5000);

                //Wait until Chocobo Registrar is visible again
                while(!chocoNpcVis())
                    await Coroutine.Sleep(3000);
            }
        }

        bool chocoNpcVis()
        {
            try
            {
                return chocoNpc.IsVisible;
            }
            catch
            {
                chocoNpc = GameObjectManager.GetObjectByNPCId(1010464);
                return false;
            }
        }

        private void KillCoroutine(ref Coroutine coroutine)
        {
            if (coroutine == null)
                return;

            coroutine.Dispose();
            coroutine = null;
        }

        private void TreeRootOnOnStop(BotBase bot)
        {
            KillCoroutine(ref _coroutine);
        }

        public void OnShutdown()
        {
        }

        public void OnDisabled()
        {
        }

        public void OnButtonPress()
        {
        }
    }
}