﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace ChocoboPlugin
{
    public static class InputManager
    {
        [DllImport("user32.dll")]
        public static extern void mouse_event(int dwFlags, int dx, int dy, int cButtons, int dwExtraInfo);

        [DllImport("user32.dll", SetLastError = true)]
        static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);

        public const int MOUSEEVENTF_LEFTDOWN = 0x02;
        public const int MOUSEEVENTF_LEFTUP = 0x04;

        public const int KEY_DOWN_EVENT = 0x0001;
        public const int KEY_UP_EVENT = 0x0002;
        public const int W_KEY = 0x57;

        public static void LeftMouseClick(int xpos, int ypos)
        {
            Cursor.Position = new Point(xpos, ypos);
            mouse_event(MOUSEEVENTF_LEFTDOWN, xpos, ypos, 0, 0);
            Thread.Sleep(1000);
            mouse_event(MOUSEEVENTF_LEFTUP, xpos, ypos, 0, 0);
        }

        public static void KeyDown()
        {
            keybd_event(W_KEY, 0, KEY_DOWN_EVENT, 0);
        }

        public static void KeyUp()
        {
            keybd_event(W_KEY, 0, KEY_UP_EVENT, 0);
        }
    }
}
